#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""

"""
from SLiCAP import *

fileName = "frequencyResponse"
specFileName = "specifications.csv"

# Define an instruction
i1 = instruction()
i1.setCircuit(fileName + '.cir')

# import the specifications
specs = csv2specs(specFileName)

# Define the circuit parameters from the specifications
specs2circuit(specs, i1)

htmlPage("Circuit Data")
head2html("Circuit diagram")
img2html(fileName + ".svg", 1000)
netlist2html(fileName + ".cir")
elementData2html(i1.circuit)
params2html(i1.circuit)
htmlPage('Antenna bandwidth limitation')
head2html("Transfer frequency characteristics")
text2html("The parasitic capcitance of the transmit coil and the receive coil " +
          "have a large influence on the frequency response of the hearing loop.")
text2html("We will investigate these influences and, if necessary, take " + 
          "measures to reduce tem.")

i1.setSimType('numeric')
i1.setGainType('gain')
i1.setDataType('laplace')
i1.setSource('V1')
i1.setDetector('V_out')

laplaceResult = i1.execute()
text2html("The figure below shows the transfer with an instantaneous " + 
          "transadmittance transmitter amplifier and an integrating voltage " +
          "receiver amplifier.")

magFig = plotSweep("magFigUndamped", "Magnitude of hearing loop Transfer", laplaceResult, 10, 1E6, 500, show=True)

fig2html(magFig, 600)

text2html("The two resonsnce peaks are cause by the self resonance of the " + 
          "transmit coil and the receive coil.")
text2html("Alhough these peaks occur outside the frequency range of interest " +
          "they increase the systems sensitivity for 'out-of-band' interference.")

text2html("We will reduce these resonances by inserting damping resistors in parallel with the coils.")