#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Mar 23 09:35:23 2022

@author: anton
"""
from sympy import pi, sqrt

# Receive coil from data sheet
Rr = 235     # DC resistance
Lr = 0.1     # Inductance
fr = 100e3   # Resonant frequency

# Send coil measuremnent
Rs = 6       # Resistance
Ls = 300e-6  # Inductance
fs = 500e3   # Resonant frequency: measured with Ri = 50Ohm

# Transfer measurement
Rg = 50      # Signal source impedance
Ri = 1e6     # Receiver input resistance
Ci = 30e-12  # Receiver input capacitance including 20cm cable
fm = 1e3     # Measurement frequency
At = -55     # Transfer from source to receive coil voltage (in dB)
             # Through measurement @fm with Ri= set to 1MOhm

# Calculation of coupling factor
             
# The source-load transfer A_t of two coupled inductosrs
"""
Equations coupled inductors measurement setup:
k     = M/sqrt(L1*L2)
Is    = Vs/sqrt((Rs+Rg)^2+ (2*pi*f*L)^2)
Vo    = j*2*pi*f*M*Is
Vo/Vs = 10^(At/20)
"""
k = (10**(At/20) * sqrt((Rg+Rs)**2 + (2*pi*fm*Ls)**2))/(2*pi*fm*sqrt(Ls*Lr))

# Calculation of parasitic capacitances
Cs = 1/(2*pi*fs)**2/Ls
Cr = 1/(2*pi*fr)**2/Lr